# HTICQ - A Web ICQ Client
# Copyright (C) 1999  Dwayne C. Litzenberger  
#  
# This program is free software; you can redistribute it and/or modify   
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
from numconv import *
from common import *
import time
import socket,select
import string
import sys,os
import pickle
import random
import md5
from threading import *

IN_PROGRAM = IN_CLIENT

#import whrandom

ICQ_version=2
MAXVER=2

MAXBUF=4096
PACKET_TIMEOUT=5	# in seconds
CLIENT_TIMEOUT=1800	# 30-minute client timeout

class BlankClass:
	pass

class CmdClass:
	def ack(x,sequence):
		print "-> ACK (" + str(sequence) + ")"
		send_packet(CMD_ACK,sequence,my_uin,'')
	def keepalive(x):
		print "-> KEEPALIVE (" + str(seq.client) + ")"
		send_packet(CMD_KEEPALIVE,seq.client,my_uin,'')
		seq.client=seq.client+1	
	def login(x,uin,passwd,status):
		p=to_dword(client_port) \
		  + to_word(len(passwd)+1) + passwd + '\000' \
		  + to_dword(0x98) + ip_to_dword(my_ip) \
		  + chr(6) + to_dword(status) + to_dword(2) + to_dword(0) \
		  + to_dword(0x980000)
		send_packet(CMD_LOGIN,seq.client,uin,p)
		print "-> LOGIN (" + str(seq.client) + ")"
		print "        UIN:" + str(uin)
		print "        Initial Status:" + str(status)
		seq.client=seq.client+1	
        def message_ack(x):
                send_packet(CMD_MESSAGE_ACK,seq.client,my_uin,'')
                print "-> MESSAGE_ACK (" + str(seq.client) + ")"
                seq.client=seq.client+1
	def login_ack(x):
		send_packet(CMD_LOGIN_ACK,seq.client,my_uin,'')
		print "-> LOGIN_ACK (" + str(seq.client) + ")"
		seq.client=seq.client+1	
	def change_status(x,newstat):
		global my_status
		p = to_dword(newstat)
		send_packet(CMD_CHANGE_STATUS,seq.client,my_uin,p)
		print "-> CHANGE_STATUS (" + str(seq.client) + ")"
		print "        New Status: " + str(newstat)
		my_status = newstat
		seq.client = seq.client+1		
	def send_contacts(x):
		x=load_contacts()
		p=chr(len(x))
		print "-> CONTACTS (" + str(seq.client) + ")"
		print "        Number:" + str(len(x))
		for i in range(len(x)):
			p=p + to_dword(x[i])
			print "        #" + str(x[i])
		send_packet(CMD_CONTACTS,seq.client,my_uin,p)
		seq.client=seq.client+1	
	def send_visibles(x):
		x=load_visibles()
		p=chr(len(x))
		print "-> VISIBLES (" + str(seq.client) + ")"
		print "        Number:" + str(len(x))
		for i in range(len(x)):
			p=p + to_dword(x[i])
			print "        #" + str(x[i])
		send_packet(CMD_CONTACTS,seq.client,my_uin,p)
		seq.client=seq.client+1	
	def send_invisibles(x):
		x=load_invisibles()
		p=chr(len(x))
		print "-> INVISIBLES (" + str(seq.client) + ")"
		print "        Number:" + str(len(x))
		for i in range(len(x)):
			p=p + to_dword(x[i])
			print "        #" + str(x[i])
		send_packet(CMD_CONTACTS,seq.client,my_uin,p)
		seq.client=seq.client+1	
	def send_message(x,uinto,msgtype,msgtxt=''):
		p=to_dword(uinto) + to_word(msgtype)
		if msgtype == ICQ_MSG_TEXT:
			p = p + to_word(len(msgtxt)) + msgtxt + chr(0)
		elif msgtype == ICQ_MSG_AUTHORIZED:
			pass 	# no message body
		else:
			assert 0 == 1		# ERROR: Unknown msgtype
		print "-> SEND_MSG (" + str(seq.client) + ")"
		print "        UIN:" + stri(uinto)
		print "        Type:" + str(msgtype)
		print "        Length:" + str(len(msgtxt))
		print "        Message:" + msgtxt
		send_packet(CMD_SEND_MSG,seq.client,my_uin,p)
		seq.client=seq.client+1	
	def info_req(x,uinto):
		p=to_word(seq.client)+to_dword(uinto)
		print "-> INFO_REQ (" + str(seq.client) + ")"
		print "        INFO_SEQ:" + stri(seq.client)	# The reply has the UIN anyway
		print "        UIN:" + stri(uinto)
		send_packet(CMD_INFO_REQ,seq.client,my_uin,p)
		seq.client=seq.client+1
	def set_auth(x,authstat):
		p=to_word(0)+to_word(authstat)
		if authstat == ICQ_AUTH_AUTH:
			t="AUTH"
		elif authstat == ICQ_AUTH_ALWAYS:
			t="ALWAYS"
		else:
			t="???"
			p=chr(1)	# This shouldn't happen anyway
		print "-> SET_AUTH (" + str(seq.client) + ")"
		print "   AUTHSTAT:" + t
		send_packet(CMD_SET_AUTH,seq.client,my_uin,p)
		seq.client=seq.client+1
	def text_code(x,text,data):
		p=to_word(len(text)+1) + text + '\000' + to_word(data)
		print "-> TEXT_CODE (" + str(seq.client) + ")"
		print "        String:" + text
		print "        Data:" + str(data)
		send_packet(CMD_TEXT_CODE,seq.client,my_uin,p)
		seq.client=seq.client+1	

class MyThreads:
	def bufmaint(x):
		global buffer,outstanding_packet
		t=time.time()-80	# don't call keepalive for 20 secs
		while not evt.bufmaint.isSet():
			update_buffer()
			if time.time() - t > 100:
				cmd.keepalive()
				t=time.time()
			if buffer != []:
				pkt=get_packet()
				if pkt['ver'] <= MAXVER:
					command=pkt['cmd']
					if command == CMD_ACK:
						try:
							i=outstanding_packet[pkt['seq']]['cmd']
							if i==CMD_CHANGE_STATUS:
								write_status()
							del outstanding_packet[pkt['seq']]
						except KeyError:
							pass
					elif command == CMD_NOT_LOGGED_IN:
						try:
							i=outstanding_packet[pkt['seq']]['cmd']
							if i==CMD_CHANGE_STATUS:
								write_status()
							del outstanding_packet[pkt['seq']]
						except KeyError:
							pass
						write_status('NOTLOGIN')
						do_logout()
					elif command == CMD_SET_AUTH_ACK:
						cmd.ack(pkt['seq'])
						write_packet(pkt)
					elif command == CMD_LOGIN_OK:
						cmd.ack(pkt['seq'])
						post_login()
					elif command == CMD_LOGIN_BADPWD:
						write_status('BADPWD')
						cmd.ack(pkt['seq'])
						do_logout()
					elif command == CMD_SRV_X1:
						cmd.ack(pkt['seq'])
					elif command == CMD_SRV_X2:
						cmd.ack(pkt['seq'])
						cmd.message_ack()
					elif command == CMD_USER_ONLINE:
						try:
							peerinfo[pkt['uin']]['status']=pkt['status']
						except KeyError:
							pass
						cmd.ack(pkt['seq'])
						write_peerinfo()
					elif command == CMD_USER_OFFLINE:
						try:
							peerinfo[pkt['uin']]['status']=ICQ_STAT_OFFLINE
						except KeyError:
							pass
						cmd.ack(pkt['seq'])
						write_peerinfo()
					elif command == CMD_STATUS_UPDATE:
						try:
							peerinfo[pkt['uin']]['status']=pkt['status']
						except KeyError:
							pass
						cmd.ack(pkt['seq'])
						write_peerinfo()
					elif command == CMD_RECV_MSG:
						cmd.ack(pkt['seq'])
						write_packet(pkt)
					elif command == CMD_INSTANT_MSG:
						cmd.ack(pkt['seq'])
						write_packet(pkt)
					elif command == CMD_INFO_REPLY:
						try:
							x=peerinfo[pkt['uin']]
						except KeyError:
							pass
						cmd.ack(pkt['seq'])
						x['alias']=pkt['alias']
						x['first_name']=pkt['first_name']
						x['last_name']=pkt['last_name']
						x['email']=pkt['email']
						x['auth']=pkt['auth']
						write_peerinfo()
					else:
						cmd.ack(pkt['seq'])

			else:	
				time.sleep(0.250)
			for k in outstanding_packet.keys():
				x=outstanding_packet[k]
				if time.time() - x['lasttime'] > PACKET_TIMEOUT:
					print "=> RESEND (" + str(k) + ")"
					send_packet(x['cmd'], k, x['uin'], x['param'],1)
			process_events()
			if time.time() - last_interface > CLIENT_TIMEOUT:
				print "! CLIENT_TIMEOUT"
				do_logout()
			
		evt.bufmaint.clear()

def process_events():
	global last_interface
	lst = os.listdir(data_dir + '/session/events/i2c')
	for i in range(len(lst)):
		file = data_dir + '/session/events/i2c/' + lst[i]
		f = open(file, 'r')
		pkt = pickle.Unpickler(f).load()
		f.close()
		command = pkt['cmd']
		last_interface=time.time()
		if command == "NOP":
			pass
		elif command == "LOGOUT":
			os.unlink(file)	        # this won't happen otherwise
			do_logout()
		elif command == "MESSAGE":
			uin = pkt['uin']
			ty = pkt['type']
			msg = pkt['message']
			cmd.send_message(uin,ty,msg)
		elif command == "RELOAD_CONTACTS":
			load_contacts()
			do_getpeers()
			write_peerinfo()
			cmd.send_contacts()
		elif command == "CHANGE_STATUS":
			s = pkt['status']
			cmd.change_status(s)
			write_status()
		elif command == "SET_AUTH":
			s = pkt['authstat']
			cmd.set_auth(s)

		os.unlink(file)

def write_packet(pkt,inprg=IN_CLIENT):          # FIXME: should be called from common.py
        IN_PROGRAM=inprg        # This should be a super-global variable, but I$
        e=1
        if IN_PROGRAM == IN_CLIENT:
                print "W> Write Packet..."
        while e:
                r = random_string(16)
                file=data_dir + '/session/events/c2i/' + r
                file2=data_dir + '/session/events/c2i-temp/' + r
                if exists(file) or exists(file2):
                        e=1
                else:
                        e=0
        f=open(file2,'w')
        pickle.dump(pkt,f)
        f.close()
        os.rename(file2,file)
        if IN_PROGRAM == IN_CLIENT:
                print "   ...done"

def get_packet():
	global buffer
	update_buffer()
	buf=buffer[0]
	version=from_word(buf[0:2])
	command=from_word(buf[2:4])
	sequence=from_word(buf[4:6]) 
	out={'ver': version, 'cmd': command, 'seq': sequence}
	buf=buf[6:]

	if command == CMD_ACK:
		print "<- ACK (" + str(sequence) + ")"
	elif command == CMD_NOT_LOGGED_IN:
		print "<- NOT_LOGGED_IN (" + str(sequence) + ")"
	elif command == CMD_SET_AUTH_ACK:
		print "<- SET_AUTH_ACK (" + str(sequence) + ")"
	elif command == CMD_FORCE_LOGOUT:
		uin=from_dword(buf[0:4])
                out['uin']=uin
		print "<- FORCE_LOGOUT (" + str(sequence) + ")"
		print "        UIN:" + str(uin)
	elif command == CMD_LOGIN_BADPWD:
		print "<- LOGIN_BADPWD (" + str(sequence) + ")"
	elif command == CMD_LOGIN_OK:
                uin=from_dword(buf[0:4])
                out['uin']=uin
		ip=dword_to_ip(buf[4:8])
		out['ip']=ip
                seq2=from_word(buf[8:10])
                out['seq2']=seq2
		x=buf[10:38]		# (XXX Unknown flags)
		print "<- LOGIN_OK (" + str(sequence) + ")"
		print "        UIN:" + str(uin)
		print "        IP:" + str(ip)
		print "        SEQ2:" + str(seq2)
	elif command == CMD_SRV_X1:
		uin=from_dword(buf[0:4])
                out['uin']=uin
		print "<- SRV_X1 (" + str(sequence) + ")"
		print "        UIN:" + str(uin)
	elif command == CMD_SRV_X2:
		uin=from_dword(buf[0:4])
                out['uin']=uin
		print "<- SRV_X2 (" + str(sequence) + ")"
		print "        UIN:" + str(uin)
	elif command == CMD_END_OF_SEARCH:
		out['done'] = ord(buf[0])
		print "<- END_OF_SEARCH (" + str(sequence) + ")"
		print "        Done:" + str(ord(buf[0]))
	elif command == CMD_RECV_MSG:
                uin=from_dword(buf[0:4])
		year=from_word(buf[4:6])
		month=ord(buf[6:7])
		day=ord(buf[7:8])
		hour=ord(buf[8:9])
		minute=ord(buf[9:10])
		msgtype=from_word(buf[10:12])
		msglen=from_word(buf[12:14])
		msgtext=buf[14:14+msglen]
		msgtime=time.mktime((year,month,day,hour,minute,0,0,0,0))-time.timezone
                out['uin']=uin
		out['time']=msgtime
		out['type']=msgtype
		out['len']=msglen
		out['message']=msgtext
		print "<- RECV_MSG (" + str(sequence) + ")"
		print "        UIN:" + str(uin)
		print "        Time:" + time.asctime(time.localtime(msgtime))
		print "        Type:" + str(msgtype)
		print "        Length:" + str(msglen)
		print "        Message:" + msgtext
	elif command == CMD_INSTANT_MSG:
                uin=from_dword(buf[0:4])
		msgtype=from_word(buf[4:6])
		msglen=from_word(buf[6:8])
		msgtext=buf[8:8+msglen-1]
		msgtime=time.time()
                out['uin']=uin
		out['time']=msgtime
		out['type']=msgtype
		out['len']=msglen
		out['message']=msgtext
		print "<- INSTANT_MSG (" + str(sequence) + ")"
		print "        UIN:" + str(uin)
		print "        Type:" + str(msgtype)
		print "        Length:" + str(msglen)
		print "        Message:" + msgtext
	elif command == CMD_USER_ONLINE:
                uin=from_dword(buf[0:4])
		ip=dword_to_ip(buf[4:8])
                port=from_word(buf[8:10])
		# buf[10:12] = 0x00  (Mirabilis thinks ports are 32-bit  :) )
		rip=dword_to_ip(buf[12:16])
		# buf[16:17] = TCP Status (4 or 6)
                status=from_word(buf[17:21])
		# buf[21:25] is probably client ICQ version
                out['uin']=uin
		out['ip']=ip
                out['port']=port
		out['real_ip']=rip
                out['status']=status
		print "<- USER_ONLINE (" + str(sequence) + ")"		
		print "        UIN:"+str(uin)
		print "        IP:"+str(ip)
		print "        PORT:"+str(port)
		print "        REAL_IP:"+str(rip)
		print "        STATUS:"+str(status)
	elif command == CMD_STATUS_UPDATE:
                uin=from_dword(buf[0:4])
                status=from_word(buf[4:8])
                out['uin']=uin
                out['status']=status
		print "<- STATUS_UPDATE (" + str(sequence) + ")"		
		print "        UIN:"+str(uin)
		print "        STATUS:"+str(status)
	elif command == CMD_USER_OFFLINE:
                uin=from_dword(buf[0:4])
                out['uin']=uin
		print "<- USER_OFFLINE (" + str(sequence) + ")"		
		print "        UIN:"+str(uin)
	elif command == CMD_INFO_REPLY:
                out['seq2'] = seq2 = from_word(buf[0:2])
                out['uin'] = uin = from_dword(buf[2:6])
                l=from_word(buf[6:8])
                out['alias'] = alias = buf[8:8+l-1]
		buf=buf[8+l:]		# easier than calculating offsets
                l=from_word(buf[0:2])
                out['first_name'] = name1 = buf[2:2+l-1]
		buf=buf[2+l:]
                l=from_word(buf[0:2])
                out['last_name'] = name2 = buf[2:2+l-1]
		buf=buf[2+l:]
                l=from_word(buf[0:2])
                out['email'] = email = buf[2:2+l-1]
		buf=buf[2+l:]
		out['auth'] = auth = ord(buf[0:1])	

		print "<- INFO_REPLY (" + str(sequence) + ")"		
		print "        SEQ2:"+str(seq2)
		print "        UIN:"+str(uin)
		print "        Alias:"+alias
		print "        Name1:"+name1
		print "        Name2:"+name2
		print "        Email:"+email
		print "        Auth:"+str(auth)
	elif command == CMD_USER_FOUND:
                out['seq2'] = seq2 = from_word(buf[0:2])
                out['uin'] = uin = from_dword(buf[2:6])
                l=from_word(buf[6:8])
                out['alias'] = alias = buf[8:8+l-1]
		buf=buf[8+l:]		# easier than calculating offsets
                l=from_word(buf[0:2])
                out['first_name'] = fname = buf[2:2+l-1]
		buf=buf[2+l:]
                l=from_word(buf[0:2])
                out['last_name'] = lname = buf[2:2+l-1]
		buf=buf[2+l:]
                l=from_word(buf[0:2])
                out['email'] = email = buf[2:2+l-1]
		buf=buf[2+l:]
		out['auth'] = auth = ord(buf[0:1])	

		print "<- USER_FOUND (" + str(sequence) + ")"		
		print "        SEQ2:"+str(seq2)
		print "        UIN:"+str(uin)
		print "        Alias:"+alias
		print "        Name1:"+name2
		print "        Name2:"+name2
		print "        Email:"+email
		print "        Auth:"+str(auth)
	else:
		print "<- *Unknown Command (" + str(sequence) + ")"
		print "        Version:" + str(version)
		print "        Command:" + str(command) + ' '+ hex(command)
		
	del buffer[0]
	return out

# Format of packet:
# 	WORD	VERSION
#	WORD	COMMAND
#	WORD	SEQUENCE
#	DWORD	UIN
#	var	PARAMETERS
def send_packet(command,sequence,uin,param,isresent=0):
	global skt,seq,outstanding_packet
	x=to_word(ICQ_version) + to_word(command) + to_word(sequence) + to_dword(uin) + param
	if command != CMD_ACK and isresent == 0:
		outstanding_packet[sequence]={'time': time.time(), 'lasttime': time.time(), 'cmd': command, 'uin': uin, 'param': param}
	if isresent == 1:
		outstanding_packet[sequence]['lasttime'] = time.time()
	skt.send(x)

def update_buffer():
	global skt,buffer,MAXBUF
	while select.select([skt], [], [],0) != ([], [], []):
		b=skt.recv(MAXBUF)
		#f=open(data_dir+'/session/recvlog','ab')	# XXX Receive log
		#f.write(b)
		#f.close()
		buffer.append(b)


def server_connect(server,port):
	global skt,seq,buffer
	global my_ip
	skt=socket.socket(socket.AF_INET,socket.SOCK_DGRAM)
	skt.connect(server,port)
	my_ip=skt.getsockname()[0]
	buffer=[]

def load_contacts():
	global peerinfo
	x=[]
	oldpi=peerinfo
	get_peerinfo()
	peerinfo = {}
	f=open(data_dir+'/contacts','r')
	j=' '
	while 1:
		j=f.readline()
		if j == '': break
		x.append(long(j))
		peerinfo[long(j)]={'alias': 'Unknown Name', 'status': ICQ_STAT_OFFLINE}
		try:
			peerinfo[long(j)]=oldpi[long(j)]	#if old info exists...
		except KeyError:
			pass
	f.close()
	return x
def load_visibles():
	x=[]
	f=open(data_dir+'/visibles','r')
	j=' '
	while 1:
		j=f.readline()
		if j == '': break
		x.append(long(j))
	f.close()
	return x
def load_invisibles():
	x=[]
	f=open(data_dir+'/invisibles','r')
	j=' '
	while 1:
		j=f.readline()
		if j == '': break
		x.append(long(j))
	f.close()
	return x

def load_server():
	f=open('data/server','r')
	server=f.readline()[:-1]
	port=int(f.readline())
	j = {'server': server, 'port': port}
	f.close()
	return j

def do_loaddata():
	global ICQ_server,ICQ_server_port
	x=load_server()
	ICQ_server=x['server']
	ICQ_server_port=x['port']

def do_login():
	server_connect(ICQ_server,ICQ_server_port)
	cmd.login(my_uin,my_pass,ICQ_STAT_ONLINE)

def post_login():
	cmd.login_ack()
	cmd.send_contacts()
	cmd.send_visibles()
	cmd.send_invisibles()
	do_getpeers()
	write_peerinfo()
	write_hash()
	write_status()
	cmd.keepalive()


def do_logout():
	cmd.text_code("B_USER_DISCONNECTED",5)
	evt.bufmaint.set()
	try:
		os.unlink(data_dir+'/session/pid')
		os.unlink(data_dir+'/session/hash')
	except OSError:
		pass
	sys.exit()
	
def get_peerinfo():
        global peerinfo
	try:
		oldpi=peerinfo
	        f=open(data_dir + '/session/peerinfo','r')
	        peerinfo=pickle.Unpickler(f).load()
	        f.close()
		for k in peerinfo.keys():	
			try:
				peerinfo[k]['status']=oldpi[k]['status']
			except KeyError:
				peerinfo[k]['status']=ICQ_STAT_OFFLINE
			
	except IOError:
		pass

def write_peerinfo(): 
	f=open(data_dir+'/session/peerinfo','w')
	pickle.dump(peerinfo,f)
	f.close()	

def write_status(l='READY'):
	f=open(data_dir+'/session/status','w')
	if l == 'READY':
		f.write('READY\n')	
		f.write(str(my_status))
	else:
		f.write(l + '\n')	
	f.close()

def write_hash(): 
        global my_pass
	f=open(data_dir+'/session/hash','w')
        m=md5.new()
        m.update(my_pass)
        h=m.digest()
	pickle.dump(h,f)
	f.close()	

def do_getpeers():
	get_peerinfo()
	for i in peerinfo.keys():
		cmd.info_req(i)

#########################################
# main #
########

# Read command line
file="data/logintemp/"+sys.argv[2]
f=open(file,'r')
my_uin=long(sys.argv[1])
my_pass=noline(f.readline())
f.close()
os.unlink(file)
data_dir='data/'+stri(my_uin)

# XXX Receive log
#f=open(data_dir+'/session/recvlog','wb')
#f.close()

# Initialize variables
peerinfo={}
outstanding_packet={}
ICQ_server=''
ICQ_server_port=0
client_port=0
my_status=-1
seq=BlankClass()
cmd=CmdClass()
thr=BlankClass()
evt=BlankClass()
seq.client=0
seq.server=0
last_interface=time.time()	# Last time event was received from client

# Initialize Buffer Maintenance thread/event
thr.bufmaint=Thread(None,MyThreads().bufmaint)
thr.bufmaint.setDaemon(1)
evt.bufmaint=Event()

do_loaddata()

f=open(data_dir+'/session/status','w')
f.write('LOGIN')
f.close()

do_login()

#cmd.set_auth(1)	# DEBUG
thr.bufmaint.start()


# Why use threading?  Comment out the next 2 lines, use python -i,
# and you have access to all the functions (eg. send message) here.
while not evt.bufmaint.isSet() and not thr.bufmaint._Thread__stopped:		# Main loop - stuff is now handled by thr.bufmaint
	time.sleep(1)

