# HTICQ - A Web ICQ Client
# Copyright (C) 1999  Dwayne C. Litzenberger  
#  
# This program is free software; you can redistribute it and/or modify   
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import re

# Byte order:
# 	bige=0		little-endian
#	bige=1		big(network)-endian

def to_word(i,bige=0):
	x=chr( i & 0xff ) + chr((i & 0xff00) / 0x100)
	if bige==1:
		x=reverse_endian(x)
	return x

def to_dword(i,bige=0):
	x=chr( i & 0xffL ) + chr((i & 0xff00L) / 0x100L ) + chr((i & 0xff0000L) / 0x10000L) + chr((i & 0xff000000L) / 0x1000000L)
	if bige == 1:
		x = reverse_endian(x)
	return x

def from_word(x,bige=0):
	i=ord(x[0]) + ord(x[1])*0x100
	if bige==1:
		x=reverse_endian(i)
	return i

def from_dword(x,bige=0):
	i=0L
	i=ord(x[0]) + ord(x[1])*0x100L + ord(x[2])*0x10000L + ord(x[3])*0x1000000L
	if bige==1:
		x=reverse_endian(i)
	return i

# IP addresses are represented in network(big)-endian order
def ip_to_dword(addr):
	a=''
	for i in re.split('\.',addr):
		a=a + chr(int(i))
	return a

def dword_to_ip(addr):
	a=''
	for i in range(len(addr)):
		a=a + str(ord(addr[i]))
		if i<3: a=a+"."
	return a

def reverse_endian(a):
	x=''
	for i in range(len(a),0,-1):
		x=x+a[i-1]
	return x


#def cksum(a):
#	x=0
#	for i in range(len(a)-1,-1,-1):
#		for j in range(0,8):
#			if ord(a[i]) & 2**j:
#				x=x+1
#	return x

